/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.allpay.charge;

import com.allpay.charge.annoation.PermissionRequire;
import com.allpay.charge.calc.define.CalcResult;
import com.allpay.charge.calc.define.ResultVO;
import org.springframework.web.bind.annotation.*;

import java.util.List;

import static com.allpay.charge.calc.define.StaticData.charge;

/**
 *
 * @author Brian
 */

@RestController
@CrossOrigin
public class ChargeMp {

    /**
     *
     * @param discCd
     * @param settAmt
     * @param brandLastMonthUsdAmt
     * @return
     */
    @PermissionRequire(value = "cg001")
    @RequestMapping("/mp/charge/merchant")
    public @ResponseBody String chargeMerchant (@RequestParam long discCd, @RequestParam long settAmt,@RequestParam /*(required = false,defaultValue = "0")*/long brandLastMonthUsdAmt) {
        // TODO code application logic here
         CalcResult r = charge.calcMerchantChargeByLastMonth(discCd, settAmt, brandLastMonthUsdAmt);
        return  r.getForJson();
     }


     @PermissionRequire(value = "cg002")
     @RequestMapping("/mp/charge/codeList")
     public @ResponseBody String chargeCodeList (@RequestBody(required = false) List<Long> discCdList) {
         CalcResult calcResult = charge.selectChargeCodeList(discCdList);
         return  calcResult.getForMessageJson();
     }

    @PermissionRequire(value = "cg003")
    @RequestMapping("/mp/charge/createDiscSingleFix")
    public @ResponseBody ResultVO createDiscSingleFix (@RequestParam long fix) throws Exception {
        //创建特殊计费(单笔固定金额）
        ResultVO resultVO = charge.createDiscSingleFix(fix);
        return resultVO;
    }

    @PermissionRequire(value = "cg004")
    @RequestMapping("mp/charge/createDiscSingleFixAndPercent")
    public @ResponseBody ResultVO createDiscSingleFixAndPercent (@RequestParam long fix,@RequestParam double percent) throws Exception {
        //创建特殊计费（单笔固定金额+百分比）
        ResultVO resultVO = charge.createDiscSingleFixAndPercent(fix,percent);
        return resultVO;
    }
    @PermissionRequire(value = "cg005")
    @RequestMapping("/mp/charge/createDiscMonthLadder2")
    public @ResponseBody ResultVO createDiscMonthLadder2 (@RequestParam long monthAmount1,@RequestParam double percent1,@RequestParam long monthAmount2,@RequestParam double percent2) throws Exception {
        //创建特殊计费（按上月交易额2级阶梯）
        ResultVO resultVO = charge.createDiscMonthLadder2(monthAmount1,percent1,monthAmount2,percent2);
        return resultVO;
    }
    @PermissionRequire(value = "cg006")
    @RequestMapping("/mp/charge/createDiscMonthLadder3")
    public @ResponseBody ResultVO createDiscMonthLadder3 (@RequestParam long monthAmount1,@RequestParam double percent1,@RequestParam long monthAmount2,@RequestParam double percent2,@RequestParam long monthAmount3,@RequestParam double percent3) throws Exception {
        //创建特殊计费（按上月交易额3级阶梯）
        ResultVO resultVO = charge.createDiscMonthLadder3(monthAmount1,percent1,monthAmount2,percent2,monthAmount3,percent3);
        return resultVO;
    }
    @PermissionRequire(value = "cg007")
    @RequestMapping("/mp/charge/createDiscMonthLadder4")
    public @ResponseBody ResultVO createDiscMonthLadder4 (@RequestParam long monthAmount1,@RequestParam double percent1,@RequestParam long monthAmount2,@RequestParam double percent2,@RequestParam long monthAmount3,@RequestParam double percent3,@RequestParam long monthAmount4,@RequestParam double percent4) throws Exception {
        //创建特殊计费（按上月交易额4级阶梯）
        ResultVO resultVO = charge.createDiscMonthLadder4(monthAmount1,percent1,monthAmount2,percent2,monthAmount3,percent3,monthAmount4,percent4);
        return resultVO;
    }
    @PermissionRequire(value = "cg008")
    @RequestMapping("/mp/charge/releaseDisc")
    public @ResponseBody ResultVO releaseDisc (@RequestParam long discCd) throws Exception {
        //生效特殊计费代码
        ResultVO resultVO = charge.releaseDisc(discCd);
        return resultVO;
    }
    @PermissionRequire(value = "cg009")
    @RequestMapping("/mp/charge/deleteDisc")
    public @ResponseBody ResultVO deleteDisc (@RequestParam long discCd) throws Exception {
        //删除特殊计费代码
        ResultVO resultVO = charge.deleteDisc(discCd);
        return resultVO;
    }
    @PermissionRequire(value = "cg010")
    @RequestMapping("/mp/charge/findCode")
    public @ResponseBody ResultVO findCode (@RequestParam (required = false)Long discCd,
                                            @RequestParam (required = false)String nm,
                                            @RequestParam (required = false)Integer status,
                                            @RequestParam ()Integer pageNum,
                                            @RequestParam ()Integer pageSize
    ) {
        //验签
        ResultVO resultVO = charge.selectFindCode(discCd,nm,status,pageNum,pageSize);
        return  resultVO;
    }
}


