/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.allpay.charge.calc.core;

import com.allpay.charge.calc.define.AlgoCfg;
import com.allpay.charge.calc.define.Const;
import com.allpay.charge.calc.define.StaticData;
import java.util.List;
import org.apache.log4j.Logger;

/**
 *
 * @author Brian
 */
public class CalcUnit {
    private static Logger logger = Logger.getLogger(CalcUnit.class);
    protected long data[]=
                {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
    		,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

    protected void initData(){
        for(int i=0;i<data.length;i++) data[i]=0L;
    }

   /***
     * 计算步骤算法
     * @param object1
     * @param operator1
     * @param object2
     * @param operator2
     * @param object3
     * @return
     */
    private long calcStep(long object1,char operator1,long object2,char operator2,long object3){
        long result = Const.Calc.ERR_CALC_STEP_L;
        switch (operator1) {
                case '*':
                    result = object1 * object2;
                    break;
                case '/':
                    result = (object1+5000) / object2;
                    break;
                case '+':
                    result = object1 + object2;
                    break;
                case '-':
                    result = object1 - object2;
                    break;
                case '>':
                    result = (object1 > object2) ? object2 : object1;
                    break;
                case '<':
                    result = (object1 < object2) ? object2 : object1;
                    break;
                case '=':
                    result = object1;
                    break;
                default:
                    break;
            }

        switch (operator2) {
                case '*':
                    result = result * object3;
                    break;
                case '/':
                    result = (result + object3 / 2)/ object3;
                    break;
                case '+':
                    result = result + object3;
                    break;
                case '-':
                    result = result - object3;
                    break;
                case '>':
                    result = (result > object3) ? object3 : object1;
                    break;
                case '<':
                    result = (result < object2) ? object3 : object1;
                    break;
                case '=':
                    result = object3;
                    break;
                default:
                    break;
            }

        return result;
    }

    /***
     * 计算手续费主过程
     * @param discCd
     * @param data
     * @return
     */
    public int calcOpr(long discCd, long[] data){
        long  pstepNo = 0;
        long pObject1,pObject2,pObject3,pResult;
        long calcRslt;
        List<AlgoCfg> list =searchDichotomy(StaticData.listAlgoCfg,discCd);
        if(list == null) return Const.Calc.ERR_ALGO_NULL;
        AlgoCfg algoCfg;
        while(pstepNo < list.size()){
            algoCfg = this.getAlgoCfg(list, (int)pstepNo);
            logger.debug("calcOpr() calc stepNo:" + pstepNo + "  algoCfg:" + algoCfg.getValues());
            if(algoCfg ==  null) {
                logger.fatal("calcOpr() return Const.Calc.ERR_ALGO_NULL /" + discCd);
                return Const.Calc.ERR_ALGO_NULL;
            }

            if(algoCfg.getOperRslt() == 0  && algoCfg.getOperator1() =='$') return Const.Calc.SUCCEED;

            //替换参数(正数不变，负数替换data数组的参数
            pObject1 = getConvertValue(algoCfg.getObject1(),data);
            pObject2 = getConvertValue(algoCfg.getObject2(),data);
            pObject3 = getConvertValue(algoCfg.getObject3(),data);
            if(pObject1==Const.Calc.ERR_CALC_STEP_L || pObject2==Const.Calc.ERR_CALC_STEP_L ||pObject3==Const.Calc.ERR_CALC_STEP_L) {
                logger.fatal("calcOpr() return  Const.Calc.ERR_CALC_STEP /" + discCd);
                return (int)Const.Calc.ERR_CALC_STEP;
            }

            pResult  = algoCfg.getOperRslt();
            if(pResult > list.size()) {     //算法配置错误，跳转目标位置超限
                logger.fatal("calcOpr() return Const.Calc.ERR_OPERRSLT_OVERLIMIT_1 /" + discCd);
                return Const.Calc.ERR_OPERRSLT_OVERLIMIT_1;
            }
            if(pResult< 0 && Math.abs(pResult)>data.length){    //算法变量参数，大于data数组数；
                logger.fatal("calcOpr() return Const.Calc.ERR_OPERRSLT_OVERLIMIT_2 /" + discCd);
                return Const.Calc.ERR_OPERRSLT_OVERLIMIT_2;
            }

            //System.out.println(algoCfg.getValues());

            if(algoCfg.getOperator1() =='L' && algoCfg.getOperator2()=='L'){//条件式比较跳转目标行
                if(pObject1 <= pObject2 && pObject2 < pObject3)  {//比较成功，转到目标行              //if(pObject1 < pObject2 && pObject2<=pObject3)  {//比较成功，转到目标行
                    pstepNo =  pResult;
                }  else {
                    pstepNo ++;                 //比较失败，顺序执行下一行
                }
            } else {//计算步骤
                calcRslt = this.calcStep(pObject1, algoCfg.getOperator1(), pObject2, algoCfg.getOperator2(), pObject3);
                if(calcRslt == Const.Calc.ERR_CALC_STEP_L) {//计算步骤中出现异常；
                    logger.fatal("calcOpr() return  Const.Calc.ERR_CALC_STEP /" + discCd);
                    return Const.Calc.ERR_CALC_STEP;
                }
                data[(int)pResult * (-1)] = calcRslt;
                pstepNo ++;
            }
        }
        logger.fatal("calcOpr() return Const.Calc.ERR_OTHER /" + discCd);
        return Const.Calc.ERR_OTHER;    //没有正常结束过程
    }

    /**
     * 转换参数过程
     * @param pObject1
     * @param data
     * @return
     */
    private long getConvertValue(long pObject1,long[] data){
        if(pObject1 < 0)  //如果参数为负数，则为参数，需要转换
        {   if(pObject1 * (-1)>= data.length) return Const.Calc.ERR_CALC_STEP_L;
            return  data[(int)pObject1 * (-1)];
        }
        else return pObject1;
    }

    /***
     * 返回计算方法列表的指定序号
     * @param list
     * @param stepNo
     * @return
     */
    private AlgoCfg getAlgoCfg(List<AlgoCfg> list,int stepNo){
        for(AlgoCfg algoCfg:list ){
            if(algoCfg.getStepNo() == stepNo) return algoCfg;
        }
        return null;
    }

/**
     * 二分法查找数据
     * @param list
     * @param find
     * @return
     */
    private List<AlgoCfg> searchDichotomy(List<AlgoCfg> list,long find){
      int low = 0;
      int high = list.size();
      int mid ;
      int algoSize;
      AlgoCfg algoCfg;

      while(low <= high) {
          mid = (low + high)/2;
          if(mid>=high) break;      //没有找到
          algoCfg = list.get(mid);
          if(algoCfg.getDiscCd() > find){
              high = mid -1;
          }else if(algoCfg.getDiscCd() <find){
              low = mid +1;
          }else {
              algoSize =(int) getAlgoSize(list,mid+1);
              return list.subList(mid - algoCfg.getStepNo(), mid + algoSize - algoCfg.getStepNo());
          }
      }
      return null;
    }

private  long getAlgoSize(List<AlgoCfg> list,int idx){
    if( idx>=list.size() || list.get(idx).getStepNo()==0 )            //如果不前行号=0，或找到列表最后一行,则返回上一行的序号（+1）
        return list.get(idx-1).getStepNo()+1;
    else return getAlgoSize(list,idx+1);
}

}
