package com.allpay.charge.calc.define;

import lombok.Data;

import java.io.Serializable;

/**
 * 统一响应信息
 *
 * @author kang.wang
 * @create 2018-12-10 15:23
 **/
@Data
public class ResultVO<T> implements Serializable {

	private static final long serialVersionUID = 1L;

	public T getData() {
		return data;
	}

	public void setData(T data) {
		this.data = data;
	}

	public String getStatus() {
		return status;
	}

	public void setStatus(String status) {
		this.status = status;
	}

	public String getMessage() {
		return message;
	}

	public void setMessage(String message) {
		this.message = message;
	}

	public static final String SUCCESS = "success";

	public static final String FAIL = "fail";

	private String status = SUCCESS;

	private String message = "OK";

	private T data;


	public ResultVO() {
		super();
	}

	public ResultVO(T data) {
		super();
		this.data = data;
	}

	public ResultVO(Throwable e) {
		super();
		this.message = e.toString();
		this.status = FAIL;
	}

}
