package com.allpay.charge.config;

import com.allpay.charge.interceptor.PermissionsInterceptor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.PathMatchConfigurer;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurationSupport;

/**
 * Created by zhang on 2018/12/20.
 */
@Configuration
public class InterceptorConfig extends WebMvcConfigurationSupport {
	@Autowired
	private PermissionsInterceptor authInterceptor;

	@Override
	public void addInterceptors(InterceptorRegistry registry) {
		registry.addInterceptor(authInterceptor).addPathPatterns("/mp/**");
		//管理平台登录之后，再开始运行
		// registry.addInterceptor(managerInterceptor).addPathPatterns("/mp/ats/**");
		super.addInterceptors(registry);
	}


	@Override
	public void configurePathMatch(PathMatchConfigurer configurer) {
		//setUseSuffixPatternMatch 后缀模式匹配
		configurer.setUseSuffixPatternMatch(false);
		//setUseTrailingSlashMatch 自动后缀路径模式匹配
		configurer.setUseTrailingSlashMatch(true);
	}
}
