/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.allpay.charge.db.controller;

import com.allpay.charge.db.exceptions.NonexistentEntityException;
import com.allpay.charge.db.exceptions.PreexistingEntityException;
import java.io.Serializable;
import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaQuery;


/**
 *
 * @author Brian
 * @param <T>
 */


public abstract class AbstractController<T> implements Serializable{
    
    private final  String EMF_NAME ="com.allpay_charge_jar_0.0.1-SNAPSHOTPU";
    
    private final  EntityManagerFactory emf = Persistence.createEntityManagerFactory(EMF_NAME);

    public EntityManager getEntityManager() {
        return emf.createEntityManager();
     }

    public void create(T entity) throws PreexistingEntityException, Exception {
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            em.persist(entity);
            em.getTransaction().commit();
        } catch (Exception ex) {
            throw ex;
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public void edit(T entity) throws NonexistentEntityException, Exception {
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            em.merge(entity);
            em.getTransaction().commit();
        } catch (Exception ex) {
            throw ex;
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }
    
      public void delete(T entity) throws NonexistentEntityException, Exception {
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            T merge = em.merge(entity);
            em.remove(merge);
            em.getTransaction().commit();
        } catch (Exception ex) {
            throw ex;
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public List<T> findEntitiesSQL(String SQL,boolean all, int maxResults, int firstResult) throws ClassNotFoundException {
        EntityManager em = getEntityManager();
        try {
            Query q =  em.createNativeQuery(SQL);
            if (!all) {
                q.setMaxResults(maxResults);
                q.setFirstResult(firstResult);
            }
            return q.getResultList();
         } finally {
            em.close();
        }
    }      
 
    public T findEntity(Class c,Object id){
        EntityManager em = getEntityManager();
        try {
            return (T) em.find(c, id);
        } finally {
            em.close();
        } 
    }

    private List<T> findEntities(Class c,boolean all, int maxResults, int firstResult) {
        EntityManager em = getEntityManager();
        try {
            CriteriaQuery cq = em.getCriteriaBuilder().createQuery();
            cq.select(cq.from(c));
            Query q = em.createQuery(cq);
            if (!all) {
                q.setMaxResults(maxResults);
                q.setFirstResult(firstResult);
            }
            return q.getResultList();
        } finally {
            em.close();
        }
    }

       
    public List<T> findEntities(Class c) {
        return findEntities( c,true, -1, -1);
    }

    public List<T> findEntities(Class c,int maxResults, int firstResult) {
        return findEntities(c,false, maxResults, firstResult);
    }
    
    
    public List<T> findEntitiesQuery(Query query,boolean all, int maxResults, int firstResult) throws ClassNotFoundException {
        EntityManager em = getEntityManager();
        try {
            if (!all) {
                query.setMaxResults(maxResults);
                query.setFirstResult(firstResult);
            }
            return query.getResultList();
         } finally {
            em.close();
        }
    }
    
}
