/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.allpay.charge.calc.core;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.allpay.charge.calc.define.*;
import com.allpay.charge.db.controller.SaChargeDiscAlgoController;
import com.allpay.charge.db.controller.SaChargeDiscCdController;
import com.allpay.charge.db.entity.DiscSingleFix;
import com.allpay.charge.db.entity.SaChargeDiscAlgo;
import com.allpay.charge.db.entity.SaChargeDiscAlgoPK;
import com.allpay.charge.db.entity.SaChargeDiscCd;
import com.allpay.charge.helper.RefreshData;
import com.allpay.charge.tools.StringTools;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import com.allpay.charge.tools.pageUtil;
import org.apache.log4j.Logger;



/**
 *
 * @author Brian
 */
public class Charge extends CalcUnit {
     private static final Logger logger = Logger.getLogger(Charge.class);

/*
     public Charge(List<AlgoCfg> list){
          StaticData.initList(list);
        }
*/

   /**
    * 计算商户手续费（标准计算）
    * @param discCd
     * @param TRANS_SETTLE_AMT      交易清算金额
    * @return
    */
   public CalcResult calcMerchantCharge(long discCd,long TRANS_SETTLE_AMT){
     CalcResult v = new CalcResult();
     //固定百分比，直接计算，代码范围：1000001~1999999
     if(discCd > 1000000 && discCd < 2000000){//固定百分比计算
         long mdr= discCd - 1000000;
         v.setResult(TRANS_SETTLE_AMT * mdr/1000000);
         v.setStatus(Const.Calc.SUCCEED);
     }else{
         data[Const.AmountIdx.TRANS_SETTLE_AMT] = TRANS_SETTLE_AMT;                        //2号位置，作为清算金额；
         data[Const.AmountIdx.MER_DISC_CODE]    = discCd;
         v.setStatus(super.calcOpr(discCd, data));
         v.setResult(data[1]);
     }
    logger.debug("calcMerchantCharge() discCd/TRANS_SETTLE_AMT/Status/Result - " +StringTools.toSplit("/", discCd,TRANS_SETTLE_AMT,v.getStatus(),v.getResult()));
    return v;
   }

   /**
    * 计算商户手续费（标准计算）
    * @param discCd
     * @param TRANS_SETTLE_AMT              交易清算金额
     * @param BRAND_LAST_MONTH_USD_AMT      商户当前交易品牌上月（美元）交易额
    * @return
    */
   public CalcResult calcMerchantChargeByLastMonth(long discCd,long TRANS_SETTLE_AMT,long BRAND_LAST_MONTH_USD_AMT){
     CalcResult v = new CalcResult();
       if(TRANS_SETTLE_AMT < 0 || TRANS_SETTLE_AMT > 999999999999L){
           v.setStatus(Const.Calc.ERR_AMOUNT_OVERLIMIT);
           return v;
       }
     //固定百分比，直接计算，代码范围：1000001~1999999
     if(discCd >=1000000 && discCd < 2000000){
         //固定百分比计算
         long mdr= discCd - 1000000;
         v.setResult((TRANS_SETTLE_AMT * mdr+500000)/1000000);
         v.setStatus(Const.Calc.SUCCEED);
     }else{
         data[Const.AmountIdx.TRANS_SETTLE_AMT]             = TRANS_SETTLE_AMT;         //2号位置，作为清算金额；
         data[Const.AmountIdx.MER_DISC_CODE]                = discCd;
         data[Const.AmountIdx.BRAND_LAST_MONTH_USD_AMT]     = BRAND_LAST_MONTH_USD_AMT;
         v.setStatus(super.calcOpr(discCd, data));
         v.setResult((data[1]));
     }







    logger.debug("calcMerchantChargeByLastMonth() discCd/TRANS_SETTLE_AMT/Status/Result - " +StringTools.toSplit("/", discCd,TRANS_SETTLE_AMT,v.getStatus(),v.getResult()));
    return v;
   }

   /***
    * 代理分润计算
    * @param discCd
    * @param TRANS_SETTLE_AMT               交易清算金额
    * @param ALL_LAST_MONTH_USD_AMT         代理机构上月美元交易金额（所有品牌）
    * @param MER_DISC_CODE                  该笔交易的商户手续费代码
    * @return
    */
    public CalcResult calcAgentCharge(long discCd,long TRANS_SETTLE_AMT,long ALL_LAST_MONTH_USD_AMT,long MER_DISC_CODE){
     CalcResult v = new CalcResult();
     //固定百分比，直接计算，代码范围：1000001~1999999
     if(discCd > 1000000 && discCd < 2000000){//固定百分比计算
         long mdr= discCd - 1000000;
         v.setResult(TRANS_SETTLE_AMT * mdr/1000000);
         v.setStatus(Const.Calc.SUCCEED);
     }else{
         this.initData();
         data[Const.AmountIdx.TRANS_SETTLE_AMT] = TRANS_SETTLE_AMT;                        //2号位置，作为清算金额；
         data[Const.AmountIdx.MER_DISC_CODE]    = MER_DISC_CODE;
         data[Const.AmountIdx.ALL_LAST_MONTH_USD_AMT] = ALL_LAST_MONTH_USD_AMT;
         v.setStatus(super.calcOpr(discCd, data));
         v.setResult(data[1]);
     }
    return v;
   }

    /**
     * ChargeCode规则说明查询
     * @param discCdList 商户手续费计费代码集合
     * @return
     */
    public CalcResult selectChargeCodeList(List<Long> discCdList) {
        CalcResult v = new CalcResult();
        List<SaChargeDiscCd> list = new ArrayList();
        List<SaChargeDiscCd> listSaChargeDiscCdStatic = StaticData.ListSaChargeDiscCd;
        List<SaChargeDiscCd> listSaChargeDiscCd = new ArrayList<>();
        listSaChargeDiscCd.addAll(listSaChargeDiscCdStatic);
        Iterator<SaChargeDiscCd> it = listSaChargeDiscCd.iterator();
            while (it.hasNext()) {
                //it.next()方法即可返回当前元素
                if (it.next().getStatus() == 1) {
                    it.remove();
                }
            }
        System.out.println(listSaChargeDiscCd.size());
        if(discCdList==null || discCdList.size()==0){
            v.setMessage(JSON.toJSONString(listSaChargeDiscCd));
            v.setStatus(Const.Calc.SUCCEED);
            return v;
        }
        discCdList.forEach((d)->{
            listSaChargeDiscCd.forEach((s)->{
                if(s.getDiscCd()==d.intValue()){
                    list.add(s);
                }
            });
        });
        if(list.size()==0){
            v.setStatus(Const.Calc.ERR_ALGO_NULL);
            return v;
        }
        v.setMessage(JSON.toJSONString(list));
        v.setStatus(Const.Calc.SUCCEED);
        return v;
    }

    /**
     * 创建特殊计费(单笔固定金额）
     * @param fix 固定金额(以分为单位)
     * @return
     */
    public ResultVO createDiscSingleFix(long fix) throws Exception {
        SaChargeDiscCdController saChargeDiscCdController = new SaChargeDiscCdController();
        SaChargeDiscCd saChargeDiscCd = new SaChargeDiscCd();
        List<SaChargeDiscCd> saChargeDiscCdsList = saChargeDiscCdController.findEntities(SaChargeDiscCd.class);
        Integer discCdNew=0;
        String new_nm="";
        String new_comment="";
        for (SaChargeDiscCd saChargeDiscCd1:saChargeDiscCdsList) {
            Integer discCd = saChargeDiscCd1.getDiscCd();
            if(2000001<=discCd && discCd<=2000999){
                if(discCdNew<=discCd){
                    discCdNew=discCd+1;
                }
            }
            String nm = saChargeDiscCd1.getNm();
            String comment = saChargeDiscCd1.getComment();
            BigDecimal bigDecimal = new BigDecimal(fix);
            BigDecimal multiply = bigDecimal.divide(new BigDecimal(100)).setScale(2);
            new_nm="固定收费"+multiply+"("+fix+"JPY/KRW)";
            new_comment="单笔固定收费"+multiply+"("+fix+"JPY/KRW)";
            if(nm.equals(new_nm) && (comment.equals(new_comment))){
                ResultVO resultVO = new ResultVO();
                resultVO.setStatus(ResultVO.FAIL);
                resultVO.setMessage("特殊计费配置重复(单笔固定金额）");
                return resultVO;
            }
        };
        //特殊计费名稱信息表信息配置
        crateSaChargeDiscCd(saChargeDiscCdController, saChargeDiscCd, discCdNew, new_nm, new_comment);

        //特殊计费功能信息表信息配置
        createSaChargeDiscAlgo(discCdNew,0,new BigInteger("-1"),fix,'=',new BigInteger("0"),' ',new BigInteger("0"));
        createSaChargeDiscAlgo(discCdNew,1,new BigInteger("0"),0,'$',new BigInteger("0"),'$',new BigInteger("0"));

        //添加完成信息刷新
        StaticData.initList();
        //响应信息返回
        ResultVO resultVO = new ResultVO();
        resultVO.setMessage("创建特殊计费(单笔固定金额）添加完成");
        DiscSingleFix discSingleFix = new DiscSingleFix();
        discSingleFix.setDiscCd(discCdNew);
        discSingleFix.setNm(new_nm);
        discSingleFix.setComment(new_comment);
        resultVO.setData(discSingleFix);
        return resultVO;
    }

    private void crateSaChargeDiscCd(SaChargeDiscCdController saChargeDiscCdController, SaChargeDiscCd saChargeDiscCd, Integer discCdNew, String new_nm, String new_comment) throws Exception {
        //特殊计费名称信息表信息配置
        saChargeDiscCd.setDiscCd(discCdNew);
        saChargeDiscCd.setDiscTp(new Short("0"));
        saChargeDiscCd.setNm(new_nm);
        saChargeDiscCd.setComment(new_comment);
        saChargeDiscCd.setStatus(1);
        saChargeDiscCd.setRecUpdTs(new Date());
        saChargeDiscCd.setRecCrtTs(new Date());
        saChargeDiscCdController.create(saChargeDiscCd);
    }

    private void createSaChargeDiscAlgo( Integer discCdNew,Integer stepNo,BigInteger OperRslt,long fix,Character Operator1,BigInteger Object2,Character Operator2,BigInteger Object3) throws Exception {
        SaChargeDiscAlgoPK saChargeDiscAlgoPK = new SaChargeDiscAlgoPK();
        SaChargeDiscAlgoController saChargeDiscAlgoController = new SaChargeDiscAlgoController();
        SaChargeDiscAlgo saChargeDiscAlgo = new SaChargeDiscAlgo();
        saChargeDiscAlgoPK.setDiscCd(discCdNew);
        saChargeDiscAlgoPK.setStepNo(stepNo);
        saChargeDiscAlgo.setSaChargeDiscAlgoPK(saChargeDiscAlgoPK);
        saChargeDiscAlgo.setOperRslt(OperRslt);
        saChargeDiscAlgo.setObject1(BigInteger.valueOf(fix));
        saChargeDiscAlgo.setOperator1(Operator1);
        saChargeDiscAlgo.setObject2(Object2);
        saChargeDiscAlgo.setOperator2(Operator2);
        saChargeDiscAlgo.setObject3(Object3);
        saChargeDiscAlgo.setStatus(1);
        saChargeDiscAlgo.setRecCrtTs(new Date());
        saChargeDiscAlgo.setRecUpdTs(new Date());
        saChargeDiscAlgoController.create(saChargeDiscAlgo);
    }
    /**
     * 创建特殊计费（单笔固定金额+百分比）
     * @param fix 固定金额(以分为单位)
     * @param percent 百分比手续费	1.2（为1.2%）
     * @return
     */
    public ResultVO createDiscSingleFixAndPercent(long fix, double percent) throws Exception {
        SaChargeDiscCdController saChargeDiscCdController = new SaChargeDiscCdController();
        SaChargeDiscCd saChargeDiscCd = new SaChargeDiscCd();
        List<SaChargeDiscCd> saChargeDiscCdsList = saChargeDiscCdController.findEntities(SaChargeDiscCd.class);
        Integer discCdNew=0;
        String new_nm="";
        String new_comment="";
        for (SaChargeDiscCd saChargeDiscCd1:saChargeDiscCdsList) {
            Integer discCd = saChargeDiscCd1.getDiscCd();
            if(2001001<=discCd && discCd<=2001999){
                if(discCdNew<=discCd){
                    discCdNew=discCd+1;
                }
            }
            String nm = saChargeDiscCd1.getNm();
            String comment = saChargeDiscCd1.getComment();
            //固定金额
            BigDecimal bigDecimal = new BigDecimal(fix);
            BigDecimal multiply = bigDecimal.divide(new BigDecimal(100)).setScale(2);
            //百分比
            String format = new DecimalFormat("0.00").format(new BigDecimal(Double.toString(percent)));
            new_nm="固定收费"+multiply+"("+fix+"JPY/KRW)+百分比"+format+"%";
            new_comment="单笔固定收费"+multiply+"("+fix+"JPY/KRW)+百分比"+format+"%";
            if(nm.equals(new_nm) && (new_comment.equals(comment))){
                ResultVO resultVO = new ResultVO();
                resultVO.setStatus(ResultVO.FAIL);
                resultVO.setMessage("特殊计费配置重复（单笔固定金额+百分比）");
                return resultVO;
            }
        }
        //特殊计费名称信息表信息配置
        crateSaChargeDiscCd(saChargeDiscCdController, saChargeDiscCd, discCdNew, new_nm, new_comment);
        //特殊计费功能信息表信息配置
        BigDecimal bigDecimal = new BigDecimal(Double.toString(percent));
        BigInteger multiply = bigDecimal.multiply(new BigDecimal("100")).toBigInteger();
        createSaChargeDiscAlgo(discCdNew,0,new BigInteger("-1"),-2,'*',multiply,'/',new BigInteger("10000"));
        createSaChargeDiscAlgo(discCdNew,1,new BigInteger("-1"),-1,'+',new BigInteger(String.valueOf(fix)),' ',new BigInteger("0"));
        createSaChargeDiscAlgo(discCdNew,2,new BigInteger("0"),0,'$',new BigInteger("0"),'$',new BigInteger("0"));

        //添加完成信息刷新
        StaticData.initList();

        //响应信息返回
        ResultVO resultVO = new ResultVO();
        resultVO.setMessage("创建特殊计费(单笔固定金额）添加完成");
        DiscSingleFix discSingleFix = new DiscSingleFix();
        discSingleFix.setDiscCd(discCdNew);
        discSingleFix.setNm(new_nm);
        discSingleFix.setComment(new_comment);
        resultVO.setData(discSingleFix);
        return resultVO;
    }


    /**
     * 创建特殊计费（单笔固定金额+百分比）
     * @param monthAmount1 上月金额（美元）
     * @param percent1 百分比手续费	1.2（为1.2%）
     * @param monthAmount2 上月金额（美元）
     * @param percent2 百分比手续费	1.2（为1.2%）
     * @return
     */
    public ResultVO createDiscMonthLadder2( long monthAmount1,double percent1,long monthAmount2, double percent2) throws Exception {
        SaChargeDiscCdController saChargeDiscCdController = new SaChargeDiscCdController();
        SaChargeDiscCd saChargeDiscCd = new SaChargeDiscCd();
        List<SaChargeDiscCd> saChargeDiscCdsList = saChargeDiscCdController.findEntities(SaChargeDiscCd.class);
        Integer discCdNew=0;
        String new_nm="";
        String new_comment="";
        for (SaChargeDiscCd saChargeDiscCd1:saChargeDiscCdsList) {
            Integer discCd = saChargeDiscCd1.getDiscCd();
            if(2002001<=discCd && discCd<=2002999){
                if(discCdNew<=discCd){
                    discCdNew=discCd+1;
                }
            }
            String nm = saChargeDiscCd1.getNm();
            String comment = saChargeDiscCd1.getComment();
            BigDecimal bigDecimal = new BigDecimal(monthAmount2);
            BigDecimal multiply = bigDecimal.divide(new BigDecimal(1000000)).setScale(2,BigDecimal.ROUND_HALF_UP);
            String format2 = new DecimalFormat("#.##").format(multiply);
            BigDecimal bigDecima2 = new BigDecimal(monthAmount1);
            BigDecimal multiply2 = bigDecima2.divide(new BigDecimal(1000000)).setScale(2,BigDecimal.ROUND_HALF_UP);
            String format = new DecimalFormat("#.##").format(multiply2);
            BigDecimal multiply3 = bigDecimal.divide(new BigDecimal(100)).setScale(2);
            String format3 = new DecimalFormat("#.00").format(multiply3);
            //百分比
            new_nm="2级阶梯计费"+percent1+"%/"+percent2+"%(上月品牌美元交易額"+format+"~"+format2+"万/MAX)";
            new_comment="品牌上月交易额（美元）:>"+format3+"，MDR="+percent2+"%;否则MDR="+percent1+"%";
            if(nm.equals(new_nm) && (new_comment.equals(comment))){
                ResultVO resultVO = new ResultVO();
                resultVO.setStatus(ResultVO.FAIL);
                resultVO.setMessage("特殊计费配置重复（2级阶梯计费）");
                return resultVO;
            }
        }
        //特殊计费名称信息表信息配置
        crateSaChargeDiscCd(saChargeDiscCdController, saChargeDiscCd, discCdNew, new_nm, new_comment);


        //特殊计费功能信息表信息配置
        BigDecimal bigDecimal = new BigDecimal(Double.toString(percent1));
        BigInteger multiply1 = bigDecimal.multiply(new BigDecimal("100")).toBigInteger();
        BigDecimal bigDecima2 = new BigDecimal(Double.toString(percent2));
        BigInteger multiply2 = bigDecima2.multiply(new BigDecimal("100")).toBigInteger();
        createSaChargeDiscAlgo(discCdNew,0,new BigInteger("2"),0,'L',new BigInteger("-11"),'L',new BigInteger(String.valueOf(monthAmount2)));
        createSaChargeDiscAlgo(discCdNew,1,new BigInteger("4"),monthAmount2,'L',new BigInteger("-11"),'L',new BigInteger("1000000000000"));
        createSaChargeDiscAlgo(discCdNew,2,new BigInteger("-1"),-2,'*',multiply1,'/',new BigInteger("10000"));
        createSaChargeDiscAlgo(discCdNew,3,new BigInteger("0"),0,'$',new BigInteger("0"),'$',new BigInteger("0"));
        createSaChargeDiscAlgo(discCdNew,4,new BigInteger("-1"),-2,'*',multiply2,'/',new BigInteger("10000"));
        createSaChargeDiscAlgo(discCdNew,5,new BigInteger("0"),0,'$',new BigInteger("0"),'$',new BigInteger("0"));
        //添加完成信息刷新
        StaticData.initList();

        //响应信息返回
        ResultVO resultVO = new ResultVO();
        resultVO.setMessage("创建特殊计费(2级阶梯计费）添加完成");
        DiscSingleFix discSingleFix = new DiscSingleFix();
        discSingleFix.setDiscCd(discCdNew);
        discSingleFix.setNm(new_nm);
        discSingleFix.setComment(new_comment);
        resultVO.setData(discSingleFix);
        return resultVO;
    }

    public ResultVO createDiscMonthLadder3(long monthAmount1, double percent1, long monthAmount2, double percent2,long monthAmount3, double percent3) throws Exception {
        SaChargeDiscCdController saChargeDiscCdController = new SaChargeDiscCdController();
        SaChargeDiscCd saChargeDiscCd = new SaChargeDiscCd();
        List<SaChargeDiscCd> saChargeDiscCdsList = saChargeDiscCdController.findEntities(SaChargeDiscCd.class);
        Integer discCdNew=0;
        String new_nm="";
        String new_comment="";
        for (SaChargeDiscCd saChargeDiscCd1:saChargeDiscCdsList) {
            Integer discCd = saChargeDiscCd1.getDiscCd();
            if(2003001<=discCd && discCd<=2003999){
                if(discCdNew<=discCd){
                    discCdNew=discCd+1;
                }
            }
            String nm = saChargeDiscCd1.getNm();
            String comment = saChargeDiscCd1.getComment();
            //1级
            BigDecimal bigDecimal = new BigDecimal(monthAmount1);
            BigDecimal multiply = bigDecimal.divide(new BigDecimal(1000000)).setScale(2,BigDecimal.ROUND_HALF_UP);
            String format = new DecimalFormat("#.##").format(multiply);
            //2级
            BigDecimal bigDecima2 = new BigDecimal(monthAmount2);
            BigDecimal multiply2 = bigDecima2.divide(new BigDecimal(1000000)).setScale(2,BigDecimal.ROUND_HALF_UP);
            String format2 = new DecimalFormat("#.##").format(multiply2);
            //3级
            BigDecimal bigDecima3 = new BigDecimal(monthAmount3);
            BigDecimal multiply3 = bigDecima3.divide(new BigDecimal(1000000)).setScale(2,BigDecimal.ROUND_HALF_UP);
            String format3 = new DecimalFormat("#.##").format(multiply3);

            BigDecimal multiply4 = bigDecima3.divide(new BigDecimal(100)).setScale(2);
            String format4 = new DecimalFormat("#.00").format(multiply4);
            BigDecimal multiply5 = bigDecima2.divide(new BigDecimal(100)).setScale(2);
            String format6 = new DecimalFormat("#.00").format(multiply5);

            new_nm="3级阶梯计费"+percent1+"%/"+percent2+"%/"+percent3+"%(上月品牌美元交易額"+format+"~"+format2+"万/"+format3+"万/MAX)";
            new_comment="品牌上月交易额(美元）:>"+format4+"，MDR="+percent3+"%;>"+format6+"，MDR="+percent2+"%;否则MDR="+percent1+"%";
            if(nm.equals(new_nm) && (new_comment.equals(comment))){
                ResultVO resultVO = new ResultVO();
                resultVO.setStatus(ResultVO.FAIL);
                resultVO.setMessage("特殊计费配置重复（3级阶梯计费）");
                return resultVO;
            }
        }
        //特殊计费名称信息表信息配置
        crateSaChargeDiscCd(saChargeDiscCdController, saChargeDiscCd, discCdNew, new_nm, new_comment);


        //特殊计费功能信息表信息配置
        BigDecimal bigDecimal = new BigDecimal(Double.toString(percent1));
        BigInteger multiply1 = bigDecimal.multiply(new BigDecimal("100")).toBigInteger();
        BigDecimal bigDecima2 = new BigDecimal(Double.toString(percent2));
        BigInteger multiply2 = bigDecima2.multiply(new BigDecimal("100")).toBigInteger();
        BigDecimal bigDecima3 = new BigDecimal(Double.toString(percent3));
        BigInteger multiply3 = bigDecima3.multiply(new BigDecimal("100")).toBigInteger();
        createSaChargeDiscAlgo(discCdNew,0,new BigInteger("3"),0,'L',new BigInteger("-11"),'L',new BigInteger(String.valueOf(monthAmount2)));
        createSaChargeDiscAlgo(discCdNew,1,new BigInteger("5"),monthAmount2,'L',new BigInteger("-11"),'L',new BigInteger(String.valueOf(monthAmount3)));
        createSaChargeDiscAlgo(discCdNew,2,new BigInteger("7"),monthAmount3,'L',new BigInteger("-11"),'L',new BigInteger("1000000000000"));
        createSaChargeDiscAlgo(discCdNew,3,new BigInteger("-1"),-2,'*',multiply1,'/',new BigInteger("10000"));
        createSaChargeDiscAlgo(discCdNew,4,new BigInteger("0"),0,'$',new BigInteger("0"),'$',new BigInteger("0"));
        createSaChargeDiscAlgo(discCdNew,5,new BigInteger("-1"),-2,'*',multiply2,'/',new BigInteger("10000"));
        createSaChargeDiscAlgo(discCdNew,6,new BigInteger("0"),0,'$',new BigInteger("0"),'$',new BigInteger("0"));
        createSaChargeDiscAlgo(discCdNew,7,new BigInteger("-1"),-2,'*',multiply3,'/',new BigInteger("10000"));
        createSaChargeDiscAlgo(discCdNew,8,new BigInteger("0"),0,'$',new BigInteger("0"),'$',new BigInteger("0"));

        //添加完成信息刷新
        StaticData.initList();

        //响应信息返回
        ResultVO resultVO = new ResultVO();
        resultVO.setMessage("创建特殊计费(3级阶梯计费）添加完成");
        DiscSingleFix discSingleFix = new DiscSingleFix();
        discSingleFix.setDiscCd(discCdNew);
        discSingleFix.setNm(new_nm);
        discSingleFix.setComment(new_comment);
        resultVO.setData(discSingleFix);
        return resultVO;
    }

    public ResultVO createDiscMonthLadder4(long monthAmount1, double percent1, long monthAmount2, double percent2, long monthAmount3, double percent3, long monthAmount4, double percent4) throws Exception {
        SaChargeDiscCdController saChargeDiscCdController = new SaChargeDiscCdController();
        SaChargeDiscCd saChargeDiscCd = new SaChargeDiscCd();
        List<SaChargeDiscCd> saChargeDiscCdsList = saChargeDiscCdController.findEntities(SaChargeDiscCd.class);
        Integer discCdNew=0;
        String new_nm="";
        String new_comment="";
        for (SaChargeDiscCd saChargeDiscCd1:saChargeDiscCdsList) {
            Integer discCd = saChargeDiscCd1.getDiscCd();
            if(2004001<=discCd && discCd<=2004999){
                if(discCdNew<=discCd){
                    discCdNew=discCd+1;
                }
            }
            String nm = saChargeDiscCd1.getNm();
            String comment = saChargeDiscCd1.getComment();
            //1级
            BigDecimal bigDecimal = new BigDecimal(monthAmount1);
            BigDecimal multiply = bigDecimal.divide(new BigDecimal(1000000)).setScale(2,BigDecimal.ROUND_HALF_UP);
            String format = new DecimalFormat("#.##").format(multiply);
            //2级
            BigDecimal bigDecima2 = new BigDecimal(monthAmount2);
            BigDecimal multiply2 = bigDecima2.divide(new BigDecimal(1000000)).setScale(2,BigDecimal.ROUND_HALF_UP);
            String format2 = new DecimalFormat("#.##").format(multiply2);
            //3级
            BigDecimal bigDecima3 = new BigDecimal(monthAmount3);
            BigDecimal multiply3 = bigDecima3.divide(new BigDecimal(1000000)).setScale(2,BigDecimal.ROUND_HALF_UP);
            String format3 = new DecimalFormat("#.##").format(multiply3);
            //4级
            BigDecimal bigDecima4 = new BigDecimal(monthAmount4);
            BigDecimal multiply4 = bigDecima4.divide(new BigDecimal(1000000)).setScale(2,BigDecimal.ROUND_HALF_UP);
            String format4 = new DecimalFormat("#.##").format(multiply4);

            BigDecimal multiply5 = bigDecima4.divide(new BigDecimal(100)).setScale(2);
            String format5 = new DecimalFormat("#.00").format(multiply5);
            BigDecimal multiply6 = bigDecima3.divide(new BigDecimal(100)).setScale(2);
            String format6 = new DecimalFormat("#.00").format(multiply6);
            BigDecimal multiply7 = bigDecima2.divide(new BigDecimal(100)).setScale(2);
            String format7= new DecimalFormat("#.00").format(multiply7);

            new_nm="4级阶梯计费"+percent1+"%/"+percent2+"%/"+percent3+"%/"+percent4+"%(上月品牌美元交易額"+format+"~"+format2+"万/"+format3+"万/"+format4+"万/MAX)";
            new_comment="品牌上月交易额(美元）:>"+format5+"，MDR="+percent4+"%;>"+format6+"，MDR="+percent3+"%;>"+format7+"，MDR="+percent2+"%;否则MDR="+percent1+"%";
            if(nm.equals(new_nm) && (new_comment.equals(comment))){
                ResultVO resultVO = new ResultVO();
                resultVO.setStatus(ResultVO.FAIL);
                resultVO.setMessage("特殊计费配置重复（4级阶梯计费）");
                return resultVO;
            }
        }

        //特殊计费名称信息表信息配置
        crateSaChargeDiscCd(saChargeDiscCdController, saChargeDiscCd, discCdNew, new_nm, new_comment);

        //特殊计费功能信息表信息配置
        BigDecimal bigDecimal = new BigDecimal(Double.toString(percent1));
        BigInteger multiply1 = bigDecimal.multiply(new BigDecimal("100")).toBigInteger();
        BigDecimal bigDecima2 = new BigDecimal(Double.toString(percent2));
        BigInteger multiply2 = bigDecima2.multiply(new BigDecimal("100")).toBigInteger();
        BigDecimal bigDecima3 = new BigDecimal(Double.toString(percent3));
        BigInteger multiply3 = bigDecima3.multiply(new BigDecimal("100")).toBigInteger();
        BigDecimal bigDecima4 = new BigDecimal(Double.toString(percent4));
        BigInteger multiply4 = bigDecima4.multiply(new BigDecimal("100")).toBigInteger();
        createSaChargeDiscAlgo(discCdNew,0,new BigInteger("4"),0,'L',new BigInteger("-11"),'L',new BigInteger(String.valueOf(monthAmount2)));
        createSaChargeDiscAlgo(discCdNew,1,new BigInteger("6"),monthAmount2,'L',new BigInteger("-11"),'L',new BigInteger(String.valueOf(monthAmount3)));
        createSaChargeDiscAlgo(discCdNew,2,new BigInteger("8"),monthAmount3,'L',new BigInteger("-11"),'L',new BigInteger(String.valueOf(monthAmount4)));
        createSaChargeDiscAlgo(discCdNew,3,new BigInteger("10"),monthAmount4,'L',new BigInteger("-11"),'L',new BigInteger("1000000000000"));
        createSaChargeDiscAlgo(discCdNew,4,new BigInteger("-1"),-2,'*',multiply1,'/',new BigInteger("10000"));
        createSaChargeDiscAlgo(discCdNew,5,new BigInteger("0"),0,'$',new BigInteger("0"),'$',new BigInteger("0"));
        createSaChargeDiscAlgo(discCdNew,6,new BigInteger("-1"),-2,'*',multiply2,'/',new BigInteger("10000"));
        createSaChargeDiscAlgo(discCdNew,7,new BigInteger("0"),0,'$',new BigInteger("0"),'$',new BigInteger("0"));
        createSaChargeDiscAlgo(discCdNew,8,new BigInteger("-1"),-2,'*',multiply3,'/',new BigInteger("10000"));
        createSaChargeDiscAlgo(discCdNew,9,new BigInteger("0"),0,'$',new BigInteger("0"),'$',new BigInteger("0"));
        createSaChargeDiscAlgo(discCdNew,10,new BigInteger("-1"),-2,'*',multiply4,'/',new BigInteger("10000"));
        createSaChargeDiscAlgo(discCdNew,11,new BigInteger("0"),0,'$',new BigInteger("0"),'$',new BigInteger("0"));


        //添加完成信息刷新
        StaticData.initList();

        //响应信息返回
        ResultVO resultVO = new ResultVO();
        resultVO.setMessage("创建特殊计费(4级阶梯计费）添加完成");
        DiscSingleFix discSingleFix = new DiscSingleFix();
        discSingleFix.setDiscCd(discCdNew);
        discSingleFix.setNm(new_nm);
        discSingleFix.setComment(new_comment);
        resultVO.setData(discSingleFix);
        return resultVO;
    }

    public ResultVO releaseDisc(long discCd) throws Exception {
        SaChargeDiscCdController saChargeDiscCdController = new SaChargeDiscCdController();
        SaChargeDiscCd entity = saChargeDiscCdController.findEntity(SaChargeDiscCd.class,Integer.valueOf(String.valueOf(discCd)));
        if(entity.getStatus()==0){
            ResultVO resultVO = new ResultVO();
            resultVO.setStatus(ResultVO.FAIL);
            resultVO.setMessage("计费代码已生效，请勿重复发送");
            return  resultVO;
        }
        entity.setStatus(0);
        saChargeDiscCdController.edit(entity);
        //生效完成信息刷新
        StaticData.initList();
        return  new ResultVO();
    }

    public ResultVO deleteDisc(long discCd) throws Exception {
        SaChargeDiscCdController saChargeDiscCdController = new SaChargeDiscCdController();
        SaChargeDiscCd entity = saChargeDiscCdController.findEntity(SaChargeDiscCd.class,Integer.valueOf(String.valueOf(discCd)));
        if(entity==null){
            ResultVO resultVO = new ResultVO();
            resultVO.setStatus(ResultVO.FAIL);
            resultVO.setMessage("计费代码不存在");
            return  resultVO;
        }
        if(entity.getStatus()==0){
            ResultVO resultVO = new ResultVO();
            resultVO.setStatus(ResultVO.FAIL);
            resultVO.setMessage("计费代码已生效，不能删除");
            return  resultVO;
        }
        //信息表信息删除
        saChargeDiscCdController.delete(entity);
        //功能表信息删除
        SaChargeDiscAlgoController saChargeDiscAlgoController = new SaChargeDiscAlgoController();
        //List<SaChargeDiscAlgo> entitiesSQL = saChargeDiscAlgoController.findEntitiesSQL("select * from sa_charge_disc_algo where disc_cd=" + entity.getDiscCd(), true, 10, 0);
        List<SaChargeDiscAlgo> entities = saChargeDiscAlgoController.findEntities(SaChargeDiscAlgo.class);
        for (SaChargeDiscAlgo sa:entities){
            if(sa.getSaChargeDiscAlgoPK().getDiscCd()==entity.getDiscCd()){
                saChargeDiscAlgoController.delete(sa);
            }
        }
        //删除完成信息刷新
        StaticData.initList();
        return new ResultVO();
    }


    public ResultVO selectFindCode(Long discCd, String nm, Integer status,Integer pageNum,Integer pageSize) {
        ResultVO v = new ResultVO();
        List<SaChargeDiscCd> list = new ArrayList();
        List<SaChargeDiscCd> listSaChargeDiscCdStatic = StaticData.ListSaChargeDiscCd;
        List<SaChargeDiscCd> listSaChargeDiscCdNew = new ArrayList<>();
        listSaChargeDiscCdNew.addAll(listSaChargeDiscCdStatic);
        if(status!=null) {
            if(status==0){
                status=1;
            }else {
                status=0;
            }
            Iterator<SaChargeDiscCd> it = listSaChargeDiscCdNew.iterator();
            while (it.hasNext()) {
                if (it.next().getStatus() ==status) {   //it.next()方法即可返回当前元素
                    it.remove();
                }
            }
        }
        List<SaChargeDiscCd> listSaChargeDiscCd = new ArrayList<>();
        if(nm!=null) {
            Iterator<SaChargeDiscCd> it = listSaChargeDiscCdNew.iterator();
            SaChargeDiscCd next =null;
            while (it.hasNext()) {
                SaChargeDiscCd sa = it.next();
                if (sa.getNm().contains(nm)) {   //it.next()方法即可返回当前元素
                   next = sa;
                   listSaChargeDiscCd.add(next);
                }
            }
        }else {
            listSaChargeDiscCd.addAll(listSaChargeDiscCdNew);
        }
        if(discCd==null){
            v.setData(pageUtil.getPage(pageNum,pageSize,listSaChargeDiscCd));
            v.setMessage("查询成功");
            v.setStatus(ResultVO.SUCCESS);
            return v;
        }
        listSaChargeDiscCd.forEach((s)->{
                if(s.getDiscCd()==discCd.intValue()){
                    list.add(s);
                }
            });
        if(list.size()==0){
            v.setMessage("未查询到");
            v.setStatus(ResultVO.FAIL);
            return v;
        }
        v.setData(pageUtil.getPage(pageNum,pageSize,list));
        v.setMessage("查询成功");
        v.setStatus(ResultVO.SUCCESS);
        return v;
    }
}
