/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.allpay.charge.db.entity;

import lombok.Data;

import java.io.Serializable;
import java.math.BigInteger;
import java.util.Date;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author Brian
 */
@Entity
@Data
@Table(name = "sa_charge_disc_algo")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "SaChargeDiscAlgo.findAll", query = "SELECT s FROM SaChargeDiscAlgo s"),
    @NamedQuery(name = "SaChargeDiscAlgo.findByDiscCd", query = "SELECT s FROM SaChargeDiscAlgo s WHERE s.saChargeDiscAlgoPK.discCd = :discCd"),
    @NamedQuery(name = "SaChargeDiscAlgo.findByStepNo", query = "SELECT s FROM SaChargeDiscAlgo s WHERE s.saChargeDiscAlgoPK.stepNo = :stepNo"),
    @NamedQuery(name = "SaChargeDiscAlgo.findByOperRslt", query = "SELECT s FROM SaChargeDiscAlgo s WHERE s.operRslt = :operRslt"),
    @NamedQuery(name = "SaChargeDiscAlgo.findByObject1", query = "SELECT s FROM SaChargeDiscAlgo s WHERE s.object1 = :object1"),
    @NamedQuery(name = "SaChargeDiscAlgo.findByOperator1", query = "SELECT s FROM SaChargeDiscAlgo s WHERE s.operator1 = :operator1"),
    @NamedQuery(name = "SaChargeDiscAlgo.findByObject2", query = "SELECT s FROM SaChargeDiscAlgo s WHERE s.object2 = :object2"),
    @NamedQuery(name = "SaChargeDiscAlgo.findByOperator2", query = "SELECT s FROM SaChargeDiscAlgo s WHERE s.operator2 = :operator2"),
    @NamedQuery(name = "SaChargeDiscAlgo.findByObject3", query = "SELECT s FROM SaChargeDiscAlgo s WHERE s.object3 = :object3"),
    @NamedQuery(name = "SaChargeDiscAlgo.findByOperIn", query = "SELECT s FROM SaChargeDiscAlgo s WHERE s.operIn = :operIn"),
    @NamedQuery(name = "SaChargeDiscAlgo.findByRecUpdUsrId", query = "SELECT s FROM SaChargeDiscAlgo s WHERE s.recUpdUsrId = :recUpdUsrId"),
    @NamedQuery(name = "SaChargeDiscAlgo.findByRecUpdTs", query = "SELECT s FROM SaChargeDiscAlgo s WHERE s.recUpdTs = :recUpdTs"),
    @NamedQuery(name = "SaChargeDiscAlgo.findByRecCrtTs", query = "SELECT s FROM SaChargeDiscAlgo s WHERE s.recCrtTs = :recCrtTs")})
public class SaChargeDiscAlgo implements Serializable {

    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected SaChargeDiscAlgoPK saChargeDiscAlgoPK;
    @Column(name = "oper_rslt")
    private BigInteger operRslt;
    @Column(name = "object1")
    private BigInteger object1;
    @Column(name = "operator1")
    private Character operator1;
    @Column(name = "object2")
    private BigInteger object2;
    @Column(name = "operator2")
    private Character operator2;
    @Column(name = "object3")
    private BigInteger object3;
    @Column(name = "oper_in")
    private Character operIn;
    @Size(max = 20)
    @Column(name = "rec_upd_usr_id")
    private String recUpdUsrId;
    @Column(name = "rec_upd_ts")
    @Temporal(TemporalType.TIMESTAMP)
    private Date recUpdTs;
    @Column(name = "rec_crt_ts")
    @Temporal(TemporalType.TIMESTAMP)
    private Date recCrtTs;
    @Column(name = "status")
    private Integer status;
    public SaChargeDiscAlgo() {
    }

    public SaChargeDiscAlgo(SaChargeDiscAlgoPK saChargeDiscAlgoPK) {
        this.saChargeDiscAlgoPK = saChargeDiscAlgoPK;
    }

    public SaChargeDiscAlgo(int discCd, int stepNo) {
        this.saChargeDiscAlgoPK = new SaChargeDiscAlgoPK(discCd, stepNo);
    }

    public SaChargeDiscAlgoPK getSaChargeDiscAlgoPK() {
        return saChargeDiscAlgoPK;
    }

    public void setSaChargeDiscAlgoPK(SaChargeDiscAlgoPK saChargeDiscAlgoPK) {
        this.saChargeDiscAlgoPK = saChargeDiscAlgoPK;
    }

    public BigInteger getOperRslt() {
        return operRslt;
    }

    public void setOperRslt(BigInteger operRslt) {
        this.operRslt = operRslt;
    }

    public BigInteger getObject1() {
        return object1;
    }

    public void setObject1(BigInteger object1) {
        this.object1 = object1;
    }

    public Character getOperator1() {
        return operator1;
    }

    public void setOperator1(Character operator1) {
        this.operator1 = operator1;
    }

    public BigInteger getObject2() {
        return object2;
    }

    public void setObject2(BigInteger object2) {
        this.object2 = object2;
    }

    public Character getOperator2() {
        return operator2;
    }

    public void setOperator2(Character operator2) {
        this.operator2 = operator2;
    }

    public BigInteger getObject3() {
        return object3;
    }

    public void setObject3(BigInteger object3) {
        this.object3 = object3;
    }

    public Character getOperIn() {
        return operIn;
    }

    public void setOperIn(Character operIn) {
        this.operIn = operIn;
    }

    public String getRecUpdUsrId() {
        return recUpdUsrId;
    }

    public void setRecUpdUsrId(String recUpdUsrId) {
        this.recUpdUsrId = recUpdUsrId;
    }

    public Date getRecUpdTs() {
        return recUpdTs;
    }

    public void setRecUpdTs(Date recUpdTs) {
        this.recUpdTs = recUpdTs;
    }

    public Date getRecCrtTs() {
        return recCrtTs;
    }

    public void setRecCrtTs(Date recCrtTs) {
        this.recCrtTs = recCrtTs;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (saChargeDiscAlgoPK != null ? saChargeDiscAlgoPK.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof SaChargeDiscAlgo)) {
            return false;
        }
        SaChargeDiscAlgo other = (SaChargeDiscAlgo) object;
        if ((this.saChargeDiscAlgoPK == null && other.saChargeDiscAlgoPK != null) || (this.saChargeDiscAlgoPK != null && !this.saChargeDiscAlgoPK.equals(other.saChargeDiscAlgoPK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.allpay.charge.db.entity.SaChargeDiscAlgo[ saChargeDiscAlgoPK=" + saChargeDiscAlgoPK + " ]";
    }

}
