package com.allpay.charge.exception.handler;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonInclude;
import lombok.Data;

import java.time.LocalDateTime;

/**
 * @Description :
 * @Author : Simon.shi
 * @Date : 2019/8/22 16:41
 * @Version : V0.0.1
 */
@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
public class ApiSuccess<T> {

    public static final String SUCCESS_CODE = "success";
    public static final String FAIL_CODE = "fail";

    public static final ApiSuccess<String> SUCCESS = new ApiSuccess<String>(SUCCESS_CODE, "ok");
    public static final ApiSuccess<String> Fail = new ApiSuccess<String>(FAIL_CODE, "fail");

    private String status;
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime timestamp;
    private T content;

    private ApiSuccess(){timestamp = LocalDateTime.now();};

    public ApiSuccess(String status,T content) {
        this.status = status;
        this.content = content;
    }

    public ApiSuccess(T content) {
        this.status = SUCCESS_CODE;
        this.content = content;
    }

    public static <T> ApiSuccess<T> ok(T content) {
        return new ApiSuccess<>(content);
    }

}
